//////////////////////////////////////////////////////////////////////////////////
// SPARK particle engine														//
// Copyright (C) 2008-2009 - Julien Fryer - julienfryer@gmail.com				//
//																				//
// This software is provided 'as-is', without any express or implied			//
// warranty.  In no event will the authors be held liable for any damages		//
// arising from the use of this software.										//
//																				//
// Permission is granted to anyone to use this software for any purpose,		//
// including commercial applications, and to alter it and redistribute it		//
// freely, subject to the following restrictions:								//
//																				//
// 1. The origin of this software must not be misrepresented; you must not		//
//    claim that you wrote the original software. If you use this software		//
//    in a product, an acknowledgment in the product documentation would be		//
//    appreciated but is not required.											//
// 2. Altered source versions must be plainly marked as such, and must not be	//
//    misrepresented as being the original software.							//
// 3. This notice may not be removed or altered from any source distribution.	//
//////////////////////////////////////////////////////////////////////////////////


#include "Core/SPK_BufferHandler.h"

namespace SPK
{
	bool BufferHandler::bufferCreation = true;

	void BufferHandler::enableBuffersCreation(bool creation)
	{
		bufferCreation = creation;
	}

	bool BufferHandler::isBuffersCreationEnabled()
	{
		return bufferCreation;
	}

	bool BufferHandler::prepareBuffers(const Group& group)
	{
		if (!checkBuffers(group))
		{
			if (isBuffersCreationEnabled())
			{
				destroyBuffers(group);
				createBuffers(group);
				return true;
			}
			return false;
		}
		return true;
	}
}
